/*****************************************************************
* File: wlan_axi_ethernet_intr.h
* Copyright (c) 2019 Mango Communications, all rights reserved
*****************************************************************/

#ifndef WLAN_AXI_ETHERNET_INTR_H_
#define WLAN_AXI_ETHERNET_INTR_H_

#include "xil_types.h"
#include "wlan_common_types.h"

// Forward declarations
struct eth_tx_queue_buffer_t;


#define WLAN_AXI_ETH_RX_INTR_BUF_SIZE 0x800 // 2KB - space allocated per pkt

intr_conn_params_t wlan_axi_eth_intr_init( peripheral_args_t* peripheral_args,
										   u32 eth_device_id,
									   	   u32 wlan_eth_link_speed,
									   	   u32 wlan_eth_mdio_phyaddr,
									   	   u32 eth_bd_mem_base,
									   	   u32 eth_bd_mem_size,
									   	   u32 num_tx_bd,
									   	   u32 tx_coalescing_count,
									   	   u32 tx_coalescing_timer );

inline u32 wlan_axi_eth_intr_send( peripheral_args_t* peripheral_args, struct eth_tx_queue_buffer_t* eth_tx_queue_buffer );
#define WLAN_AXI_ETH_INTR_SEND_ERR_NO_FREE_BD 	0x00000001
#define WLAN_AXI_ETH_INTR_SEND_ERR_INVALID_ARGS 0x00000002
#define WLAN_AXI_ETH_INTR_SEND_ERR_OTHER 		0x00000003


void wlan_axi_eth_intr_attach_bd(dl_list* rx_queue_list);
void wlan_axi_eth_intr_attach_free_rx_bd(peripheral_args_t* peripheral_args);

int wlan_axi_eth_intr_get_mtu();

#endif //WLAN_AXI_ETHERNET_INTR_H_

