/** @file wlan_platform_intc.c
 *
 *  Wrapper for axi_intc interrupt controller driver
 *
 *  @copyright Copyright 2013-2019, Mango Communications. All rights reserved.
 *          Distributed under the Mango Communications Reference Design License
 *                See LICENSE.txt included in the design archive or
 *                at http://mangocomm.com/802.11/license
 *
 *  This file is part of the Mango 802.11 Reference Design (https://mangocomm.com/802.11)
 */

// Required for interrupt_state_t and wlan_intr_handler_t types

#include "xil_types.h"
#include "wlan_common_types.h"
#include "wlan_high_types.h"

// Function prototypes
interrupt_state_t wlan_platform_intc_stop();
int wlan_platform_intc_start();
int wlan_platform_intc_set_state(interrupt_state_t new_interrupt_state);
interrupt_state_t wlan_platform_intc_get_state();

int wlan_platform_intc_init(u32 intc_dev_id);
void wlan_platform_interrupt_disable(u32 intr_id);
void wlan_platform_interrupt_enable(u32 intr_id);
int wlan_platform_interrupt_connect(u32 intr_id, wlan_intr_handler_t handler, void *callback_ref);

