/** @file wlan_platform_timer.h
 *
 *  Header for wlan_axi_timer.c wrapper that conforms to high platform timer API requirements
 *
 *  @copyright Copyright 2013-2019, Mango Communications. All rights reserved.
 *          Distributed under the Mango Communications Reference Design License
 *                See LICENSE.txt included in the design archive or
 *                at http://mangocomm.com/802.11/license
 *
 *  This file is part of the Mango 802.11 Reference Design (https://mangocomm.com/802.11)
 */

// Required for function_ptr_t type
#include "wlan_high_types.h"

// Function prototypes - these functions must be implemented by whatever
//  peripheral driver wrapper provides timer functionality
int  wlan_timer_init(int timer_dev_id, u32 interval);
int wlan_timer_setup_interrupt(int int_id, function_ptr_t callback);
void wlan_timer_start();
int  wlan_timer_stop();
