/** @file ascii_characters.h
 *  @brief ASCII characters
 *
 *  @copyright Copyright 2013-2019, Mango Communications. All rights reserved.
 *          Distributed under the Mango Communications Reference Design License
 *              See LICENSE.txt included in the design archive or
 *              at http://mangocomm.com/802.11/license
 *
 *  This file is part of the Mango 802.11 Reference Design (https://mangocomm.com/802.11)
 */

#ifndef ASCII_CHARACTERS_H_
#define ASCII_CHARACTERS_H_


//Define shortcuts for the alphanumeric ASCII characters
// These are useful when debugging the MAC/PHY interactive via the UART

#define ASCII_A 0x41
#define ASCII_B 0x42
#define ASCII_C 0x43
#define ASCII_D 0x44
#define ASCII_E 0x45
#define ASCII_F 0x46
#define ASCII_G 0x47
#define ASCII_H 0x48
#define ASCII_I 0x49
#define ASCII_J 0x4A
#define ASCII_K 0x4B
#define ASCII_L 0x4C
#define ASCII_M 0x4D
#define ASCII_N 0x4E
#define ASCII_O 0x4F
#define ASCII_P 0x50
#define ASCII_Q 0x51
#define ASCII_R 0x52
#define ASCII_S 0x53
#define ASCII_T 0x54
#define ASCII_U 0x55
#define ASCII_V 0x56
#define ASCII_W 0x57
#define ASCII_X 0x58
#define ASCII_Y 0x59
#define ASCII_Z 0x5A

#define ASCII_a 0x61
#define ASCII_b 0x62
#define ASCII_c 0x63
#define ASCII_d 0x64
#define ASCII_e 0x65
#define ASCII_f 0x66
#define ASCII_g 0x67
#define ASCII_h 0x68
#define ASCII_i 0x69
#define ASCII_j 0x6A
#define ASCII_k 0x6B
#define ASCII_l 0x6C
#define ASCII_m 0x6D
#define ASCII_n 0x6E
#define ASCII_o 0x6F
#define ASCII_p 0x70
#define ASCII_q 0x71
#define ASCII_r 0x72
#define ASCII_s 0x73
#define ASCII_t 0x74
#define ASCII_u 0x75
#define ASCII_v 0x76
#define ASCII_w 0x77
#define ASCII_x 0x78
#define ASCII_y 0x79
#define ASCII_z 0x7A

//Number keys
#define ASCII_0 0x30
#define ASCII_1 0x31
#define ASCII_2 0x32
#define ASCII_3 0x33
#define ASCII_4 0x34
#define ASCII_5 0x35
#define ASCII_6 0x36
#define ASCII_7 0x37
#define ASCII_8 0x38
#define ASCII_9 0x39

//Shift-number keys
#define ASCII_EXCLMPT 0x21
#define ASCII_ATSIGN 0x40
#define ASCII_HASH 0x23
#define ASCII_DOLLAR 0x24
#define ASCII_PERCENT 0x25
#define ASCII_CARROT 0x5E
#define ASCII_AMPRSND 0x26
#define ASCII_ASTERISK 0x2A
#define ASCII_PARENSL 0x28
#define ASCII_PARENSR 0x29

#define ASCII_UP 30
#define ASCII_DOWN 31
#define ASCII_LEFT 28
#define ASCII_RIGHT 29

#define ASCII_SPACE 0x20
#define ASCII_DASH 0x2D

#define ASCII_SHIFT_0 ASCII_PARENSR
#define ASCII_SHIFT_1 ASCII_EXCLMPT
#define ASCII_SHIFT_2 ASCII_ATSIGN
#define ASCII_SHIFT_3 ASCII_HASH
#define ASCII_SHIFT_4 ASCII_DOLLAR
#define ASCII_SHIFT_5 ASCII_PERCENT
#define ASCII_SHIFT_6 ASCII_CARROT
#define ASCII_SHIFT_7 ASCII_AMPRSND
#define ASCII_SHIFT_8 ASCII_ASTERISK
#define ASCII_SHIFT_9 ASCII_PARENSL

#define ASCII_ESC 27
#define ASCII_CR 13
#define ASCII_DEL 127

#endif //ASCII_CHARACTERS_H_
