/** @file wlan_exp.h
 *  @brief Experiment Framework (Common)
 *
 *  This contains the code for WLAN Experimental Framework.
 *
 *  @copyright Copyright 2014-2019, Mango Communications. All rights reserved.
 *          Distributed under the Mango Communications Reference Design License
 *                See LICENSE.txt included in the design archive or
 *                at http://mangocomm.com/802.11/license
 *
 *  This file is part of the Mango 802.11 Reference Design (https://mangocomm.com/802.11)
 */

/***************************** Include Files *********************************/
// Include xil_types so function prototypes can use u8/u16/u32 data types
#include "xil_types.h"


/*************************** Constant Definitions ****************************/
#ifndef WLAN_EXP_H_
#define WLAN_EXP_H_


// **********************************************************************
// Version Information
//

// Version info:  MAJOR.MINOR.REV
//     [31:24]  - MAJOR (u8)
//     [23:16]  - MINOR (u8)
//     [15:0]   - REVISION (u16)
//
#define WLAN_EXP_VER_MAJOR                                 1
#define WLAN_EXP_VER_MINOR                                 8
#define WLAN_EXP_VER_REV                                   0

#define REQ_WLAN_EXP_HW_VER                               (WLAN_EXP_VER_MAJOR << 24)|(WLAN_EXP_VER_MINOR << 16)|(WLAN_EXP_VER_REV)


#define WLAN_EXP_HIGH_SW_ID_AP             0x01
#define WLAN_EXP_HIGH_SW_ID_STA            0x02
#define WLAN_EXP_HIGH_SW_ID_IBSS           0x03

#define WLAN_EXP_LOW_SW_ID_DCF             0x01
#define WLAN_EXP_LOW_SW_ID_NOMAC           0x02

/*********************** Global Structure Definitions ************************/


/*************************** Function Prototypes *****************************/


#endif /* WLAN_EXP_H_ */
