# -*- coding: utf-8 -*-
"""
------------------------------------------------------------------------------
Mango 802.11 Reference Design Experiments Framework - Newtork / Node Configurations
------------------------------------------------------------------------------
License:   Copyright 2019 Mango Communications, Inc. All rights reserved.
           Use and distribution subject to terms in LICENSE.txt
------------------------------------------------------------------------------

This module provides class definitions to manage the configuration of 
 wlan_exp node objects and network interfaces.

Functions (see below for more information):
    WlanExpNetworkConfiguration() -- Specifies Network information for setup
    WlanExpNodesConfiguration()   -- Specifies Node information for setup
"""

__all__ = ['WlanExpNetworkConfiguration', 'WlanExpNodesConfiguration']

# WlanExpNetworkConfiguration and WlanExpNodesConfiguration used to be a subclasses of 
#  NetworkConfiguration and NodesConfiguration, but didn't do anything except call the 
#  superclass init. The renames below are a half-step to merging wlan_exp.transport.config 
#  into wlan_exp.config
from wlan_exp.transport.config import NetworkConfiguration as WlanExpNetworkConfiguration
from wlan_exp.transport.config import NodesConfiguration as WlanExpNodesConfiguration

# End Class
